// -*-C++-*-
//
//  This file is part of SSim, a simple discrete-event simulator.
//  http://www.cs.colorado.edu/serl/ssim/
//
//  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2004-2005 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: testheap.cc,v 1.2 2005/01/06 10:34:54 carzanig Exp $
//
#include <string>
#include <iostream>

#include "../heap.h"

using namespace std;
using namespace ssim;

int main(int argc, char *argv[]) {
    heap<int> H;

    int i;
    while(cin >> i) {
	if (i < 0) {
	    if (H.empty()) {
		cout << "empty" << endl;
	    } else {
		cout << H.pop_first() << endl;
	    }
	} else {
	    H.insert(i);
	}
    }
    return 0;
}


